config/routes.rb
Support::Engine.routes.draw do
  resources :tickets
  resources :messages do
    get 'confirm', on: :member
  end
end

app/models/support/application_record.rb
module Support
  class ApplicationRecord < ActiveRecord::Base
    self.abstract_class = true
  end
end

app/models/support/message.rb
module Support
  class Message < ApplicationRecord
    self.table_name = 'support_messages'

    belongs_to :user
    belongs_to :ticket, inverse_of: :messages

    validates :content, presence: true

    after_create :update_ticket

    private

    def update_ticket
      update = {}
      if user.admin? && !ticket.state_rejected? && !ticket.state_answered?
        if ticket.messages.count > 1
          update[:state] = :answered
        end
      elsif !ticket.state_new?
        update[:state] = :replied
      end
      if user.admin? && ticket.admin != user
        update[:admin] = user
      end
      if update.any?
        ticket.update(update)
      end
    end

  end
end

app/models/support/ticket.rb
#
# attributes:
# string   subject
# boolean  is_public
# text     note
#
module Support
  class Ticket < ApplicationRecord
    self.table_name = 'support_tickets'

    has_code length: 6, type: :numeric

    belongs_to :admin, class_name: "User", optional: true
    belongs_to :user
    has_many :messages, -> { order("created_at") }, dependent: :destroy
    has_and_belongs_to_many :users, foreign_key: :support_ticket_id

    enum :state, [:new, :answered, :replied, :resolved, :rejected], default: :new, prefix: true

    validates :subject, presence: true, length: { maximum: 200 }

    scope :open,   -> { where(state: ['new', 'answered', 'replied']) }
    scope :closed, -> { where(state: ['resolved', 'rejected']) }

    after_save :update_users

    #
    # normal users don't see the full state
    #

    USER_STATES = {
      "new"       => "new",
      "answered"  => "in_progress",
      "replied"   => "in_progress",
      "resolved"  => "closed",
      "rejected"  => "closed"
    }

    def state_for_user
      USER_STATES[state]
    end

    def is_user?(user)
      users.exists?(user.id)
    end

    def open?
      state_new? || state_answered? || state_replied?
    end

    def closed?
      !open?
    end

    # all the non-admin participants of this ticket
    def requesters
      @requesters ||= users.select {|u| !u.admin?}
    end

    # all the admin participants of this ticket
    def admins
      @admins ||= users.select {|u| u.admin?}
    end

    # updates ticket users that something has changed about the ticket
    def send_notification(message)
      if message.user.admin?
        self.requesters.each do |user|
          email = Support::Mailer.with(user: user, ticket: self).ticket_updated
          email.deliver_now
        end
      end
    end

    private

    def update_users
      if admin_previously_changed?
        self.users << admin if admin && !self.users.exists?(admin_id)
      end
      if user_previously_changed?
        self.users << user if user && !self.users.exists?(user_id)
      end
    end
  end
end

app/controllers/admin/support/messages_controller.rb
class Admin::Support::MessagesController < AdminApp::ApplicationController
  layout 'modal'

  before_action :get_message, only: [:edit, :update, :confirm, :destroy]

  def edit
    render 'support/messages/edit'
  end

  def update
    if @message.update(params.require(:message).permit(:content))
      redirect_to ticket_url(@message.ticket)
    else
      render 'support/messages/edit'
    end
  end

  def create
    @ticket = Support::Ticket.find(params[:ticket_id])
    @new_message = @ticket.messages.build(content: params[:message][:content], user: current_user)
    if @new_message.save
      @ticket.send_notification(@new_message)
      redirect_to ticket_url(@ticket), notice: "Message posted."
    else
      render 'support/messages/new'
    end
  end

  def confirm
    render 'support/messages/confirm'
  end

  def destroy
    @message.destroy
    redirect_to ticket_url(@message.ticket), notice: "Message deleted."
  end

  private

  def get_message
    @message = Support::Message.find(params[:id])
  end
end

app/controllers/admin/support/tickets_controller.rb
class Admin::Support::TicketsController < AdminApp::ApplicationController
  helper Support::TicketHelper
  before_action :get_ticket, only: [:show, :destroy, :update]

  def index
    @tickets = Support::Ticket.
      order(updated_at: :desc).
      includes(:users).
      page(params[:page])
    if params[:view]
      @tickets = @tickets.where(state: params[:view])
    end
    if params[:filter]
      @tickets = @tickets.left_outer_joins(:users).where('users.id = ?', current_user.id)
    end
  end

  def show
    @new_message = Support::Message.new
  end

  def update
    @ticket = Support::UpdateTicketForm.new(ticket: @ticket, params: params)
    if @ticket.save
      redirect_to ticket_url(@ticket), **@ticket.flash
    else
      render :show
    end
  end

  def new
    if Rails.env.development?
      @ticket = Support::NewTicketForm.new(email: params[:email], subject: Faker::Lorem.sentence, message: Faker::Lorem.paragraph)
    else
      @ticket = Support::NewTicketForm.new(email: params[:email])
    end
  end

  def create
    @ticket = Support::NewTicketForm.new(ticket_params.merge(admin: current_user))
    if @ticket.save
      redirect_to ticket_url(@ticket), notice: "Ticket was successfully created."
    else
      render :new, status: :unprocessable_entity
    end
  end

  def destroy
    @ticket.destroy
    redirect_to tickets_url
  end

  private

  def ticket_params
    params.require(:ticket).permit(:subject, :message, :email)
  end

  def get_ticket
    @ticket = Support::Ticket.from_param(params[:id])
  end
end

app/controllers/support/messages_controller.rb
module Support
  class MessagesController < UserApp::ApplicationController
    layout 'modal'

    require_authentication allowed_user_scope: :tickets
    before_action :get_message, only: [:edit, :update, :confirm, :destroy]

    def edit
    end

    def update
      if @message.update(params.require(:message).permit(:content))
        redirect_to ticket_url(@message.ticket)
      else
        render 'edit'
      end
    end

    def create
      @ticket = Ticket.find(params[:ticket_id])
      permit! { current_user.admin? || @ticket.is_user?(current_user) }

      @new_message = @ticket.messages.build(content: params[:message][:content], user: current_user)
      if @new_message.save
        send_notification(@ticket)
        redirect_to ticket_url(@ticket), notice: "Message posted."
      else
        render 'new'
      end
    end

    def confirm
    end

    def destroy
      @message.destroy
      redirect_to ticket_url(@message.ticket), notice: "Message deleted."
    end

    private

    def get_message
      @message = Message.find(params[:id])
      permit! { current_user.admin? || @message.user == current_user }
    end

    def send_notification(ticket)
      if current_user.admin?
        ticket.requesters.each do |user|
          email = Support::Mailer.with(user: user, ticket: ticket).ticket_updated
          email.deliver_now
        end
      end
    end

  end
end

app/controllers/support/tickets_controller.rb
module Support
  class TicketsController < UserApp::ApplicationController
    helper Support::TicketHelper

    require_authentication allowed_user_scope: :tickets
    permit :index, :new

    before_action :get_ticket, only: [:show, :destroy, :update]

    def index
      if current_user.admin?
        @tickets = Support::Ticket.
          order(updated_at: :desc).
          includes(:users).
          page(params[:page])
        if params[:view]
          @tickets = @tickets.where(state: params[:view])
        end
        if params[:filter]
          @tickets = @tickets.left_outer_joins(:users).where('users.id = ?', current_user.id)
        end
      else
        @tickets = Support::Ticket.
          order(updated_at: :desc).
          left_outer_joins(:users).
          where('users.id = ?', current_user.id).
          page(params[:page])
      end
    end

    def show
      @new_message = Support::Message.new
    end

    def update
      @ticket = Support::UpdateTicketForm.new(ticket: @ticket, params: params)
      if @ticket.save
        redirect_to ticket_url(@ticket)
      else
        render :show
      end
    end

    def new
      if Rails.env.development?
        @ticket = NewTicketForm.new(subject: Faker::Lorem.sentence, message: Faker::Lorem.paragraph)
      else
        @ticket = NewTicketForm.new
      end
    end

    def create
      permit! {true} # you can always create your own tickets
      @ticket = NewTicketForm.new(ticket_params.merge(user: current_user))
      if @ticket.save
        redirect_to ticket_url(@ticket), notice: "Ticket was successfully created."
      else
        render :new, status: :unprocessable_entity
      end
    end

    def destroy
    end

    private

    def ticket_params
      params.require(:ticket).permit(:subject, :message, :email)
    end

    #
    # allow viewing an order unauthenticated if and only if we
    # are using the encrypted URL
    #
    def get_ticket
      if current_user
        @ticket = Support::Ticket.from_param(params[:id])
        permit! { current_user.admin? || @ticket.is_user?(current_user) }
      else
        @ticket, user, expire = Support::Ticket.parse_encrypted_code(params[:id])
        permit! { @ticket.is_user?(user) }
        scoped_log_in(user, :tickets)
      end
    end
  end
end

app/helpers/support/ticket_helper.rb
module Support
  module TicketHelper
    def ticket_state(ticket, admin: false)
      color = if ticket.state_new?
        'success'
      elsif ticket.state_resolved? || ticket.state_rejected?
        'dark'
      else
        'primary'
      end
      content_tag(:span, class: "badge text-bg-#{color}") do
        if admin
          ticket.state.sub('_', ' ')
        else
          ticket.state_for_user.sub('_', ' ')
        end
      end
    end

  end
end

app/views/admin/support/tickets/_state.html.haml
%div{style: 'margin-bottom: 2.5rem; margin-top: 1.5rem'}
  = form_with(url: ticket_path(@ticket), method: 'put') do
    = hidden_field_tag 'update-state', 'yes'
    = v.progress_tracker(mode: 'step', label_position: 'under', width: 'shrink') do |progress|
      - progress.with_step name: 'state-new',
        icon: 'stars',
        color: @ticket.state == 'new' ? 'primary' : 'secondary',
        label: 'New Ticket',
        active: @ticket.state == 'new'
      - progress.with_step name: 'state-replied',
        icon: 'reply',
        color: @ticket.state == 'replied' ? 'primary' : 'secondary',
        label: 'User Replied',
        active: @ticket.state == 'replied'
      - progress.with_step name: 'state-answered',
        icon: 'check2',
        color: @ticket.state == 'answered' ? 'primary' : 'secondary',
        label: 'Answered',
        active: @ticket.state == 'answered'
      - progress.with_step name: 'state-resolved',
        icon: 'hand-thumbs-up',
        color: @ticket.state == 'resolved' ? 'primary' : 'secondary',
        label: 'Closed',
        active: @ticket.state == 'resolved'
      - progress.with_step name: 'state-rejected',
        icon: 'hand-thumbs-down',
        color: @ticket.state == 'rejected' ? 'primary' : 'secondary',
        label: 'Rejected',
        active: @ticket.state == 'rejected'

app/views/admin/support/tickets/index.html.haml
= breadcrumbs do |bc|
  - bc.with_endmatter do
    = link_to(icon('plus-circle'), new_ticket_path, class: 'text-success')

- path = {view: params[:view], filter: params[:filter]}
= v.tab_bar do |bar|
  - bar.with_tab url: tickets_path(path.merge(view: nil)),        label: 'All',      active: active(view: nil)
  - bar.with_tab url: tickets_path(path.merge(view: 'new')),      label: 'New',      active: active(view: 'new')
  - bar.with_tab url: tickets_path(path.merge(view: 'replied')),  label: 'Replied',  active: active(view: 'replied')
  - bar.with_tab url: tickets_path(path.merge(view: 'answered')), label: 'Answered', active: active(view: 'answered')
  - bar.with_tab url: tickets_path(path.merge(view: 'resolved')), label: 'Resolved', active: active(view: 'resolved')
  - bar.with_tab url: tickets_path(path.merge(view: 'rejected')), label: 'Rejected', active: active(view: 'rejected')
  - bar.with_endmatter do
    .btn-toolbar
      - if path[:filter] == 'mine'
        = v.link_button(url: tickets_path(path.merge(filter: nil)), label: "My Tickets", border: false, size: :sm, icon: 'check-square-trim')
      - else
        = v.link_button(url: tickets_path(path.merge(filter: 'mine')), label: "My Tickets", border: false, size: :sm, icon: 'square-trim')

.mt-3
  = paginate(@tickets)

%table.table.mt-3
  %tr
    %th ID
    %th State
    %th Admin
    %th User
    %th Subject
    -#%th Created
    -#%th Updated
  - if @tickets.empty?
    %tr
      %td(colspan=7) No Tickets
  - else
    - @tickets.each do |ticket|
      %tr
        %td= link_to ticket.code, ticket
        %td= ticket_state ticket, admin: current_user.admin?
        %td= ticket.admin&.username
        %td= ticket.user&.username
        %td= link_to ticket.subject, ticket
        -#%td= time_ago ticket.created_at
        -#%td= time_ago ticket.updated_at

app/views/admin/support/tickets/new.html.haml
= v.breadcrumbs do |bc|
  - bc.with_home( admin_app.home_path )
  - bc.with_crumb { link_to('Tickets', admin_support.tickets_path) }
  - bc.with_crumb(active: true) { "New Ticket" }

%h2 New Support Ticket

= bootstrap_form_with(model: @ticket) do |form|
  = form.alert_message "Please fix the errors below", error_summary: false
  = form.text_field :email
  = form.text_field :subject
  = form.text_area :message, label: 'Message', rows: 8
  = form.cancel admin_support.tickets_path
  = form.save_button 'Create Ticket', icon: 'ticket-perforated'

app/views/admin/support/tickets/show.html.haml
= v.breadcrumbs do |bc|
  - bc.with_home( admin_app.home_path )
  - bc.with_crumb { link_to('Tickets', admin_support.tickets_path) }
  - bc.with_crumb(active: true) { @ticket.code }

= render 'state'
= render 'support/tickets/show'